/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type {
  FunctionFragment,
  Result,
  EventFragment,
} from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
} from "../common";

export declare namespace IVKLIMMarket {
  export type ListedNFTStruct = {
    owner: string;
    price: BigNumberish;
    amount: BigNumberish;
  };

  export type ListedNFTStructOutput = [string, BigNumber, BigNumber] & {
    owner: string;
    price: BigNumber;
    amount: BigNumber;
  };
}

export interface IVKLIMMarketInterface extends utils.Interface {
  functions: {
    "DEFAULT_ADMIN_ROLE()": FunctionFragment;
    "auctionTime()": FunctionFragment;
    "buyItemERC1155(uint256)": FunctionFragment;
    "buyItemERC721(uint256)": FunctionFragment;
    "cancelERC1155(uint256)": FunctionFragment;
    "cancelERC721(uint256)": FunctionFragment;
    "createItemERC1155(string,address,uint256)": FunctionFragment;
    "createItemERC721(string,address)": FunctionFragment;
    "erc1155CollectionLength()": FunctionFragment;
    "erc1155Contract()": FunctionFragment;
    "erc20Contract()": FunctionFragment;
    "erc721CollectionLength()": FunctionFragment;
    "erc721Contract()": FunctionFragment;
    "finishAuctionERC1155(uint256)": FunctionFragment;
    "finishAuctionERC721(uint256)": FunctionFragment;
    "getRoleAdmin(bytes32)": FunctionFragment;
    "grantRole(bytes32,address)": FunctionFragment;
    "hasRole(bytes32,address)": FunctionFragment;
    "listItemERC1155(uint256,uint256,uint256)": FunctionFragment;
    "listItemERC721(uint256,uint256)": FunctionFragment;
    "listItemOnAuctionERC1155(uint256,uint256,uint256)": FunctionFragment;
    "listItemOnAuctionERC721(uint256,uint256)": FunctionFragment;
    "listedERC1155(uint256)": FunctionFragment;
    "listedERC721(uint256)": FunctionFragment;
    "makeBidERC1155(uint256,uint256)": FunctionFragment;
    "makeBidERC721(uint256,uint256)": FunctionFragment;
    "onERC1155BatchReceived(address,address,uint256[],uint256[],bytes)": FunctionFragment;
    "onERC1155Received(address,address,uint256,uint256,bytes)": FunctionFragment;
    "onERC721Received(address,address,uint256,bytes)": FunctionFragment;
    "renounceRole(bytes32,address)": FunctionFragment;
    "revokeRole(bytes32,address)": FunctionFragment;
    "supportsInterface(bytes4)": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "DEFAULT_ADMIN_ROLE"
      | "auctionTime"
      | "buyItemERC1155"
      | "buyItemERC721"
      | "cancelERC1155"
      | "cancelERC721"
      | "createItemERC1155"
      | "createItemERC721"
      | "erc1155CollectionLength"
      | "erc1155Contract"
      | "erc20Contract"
      | "erc721CollectionLength"
      | "erc721Contract"
      | "finishAuctionERC1155"
      | "finishAuctionERC721"
      | "getRoleAdmin"
      | "grantRole"
      | "hasRole"
      | "listItemERC1155"
      | "listItemERC721"
      | "listItemOnAuctionERC1155"
      | "listItemOnAuctionERC721"
      | "listedERC1155"
      | "listedERC721"
      | "makeBidERC1155"
      | "makeBidERC721"
      | "onERC1155BatchReceived"
      | "onERC1155Received"
      | "onERC721Received"
      | "renounceRole"
      | "revokeRole"
      | "supportsInterface"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "DEFAULT_ADMIN_ROLE",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "auctionTime",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "buyItemERC1155",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "buyItemERC721",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "cancelERC1155",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "cancelERC721",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "createItemERC1155",
    values: [string, string, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "createItemERC721",
    values: [string, string]
  ): string;
  encodeFunctionData(
    functionFragment: "erc1155CollectionLength",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "erc1155Contract",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "erc20Contract",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "erc721CollectionLength",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "erc721Contract",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "finishAuctionERC1155",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "finishAuctionERC721",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "getRoleAdmin",
    values: [BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "grantRole",
    values: [BytesLike, string]
  ): string;
  encodeFunctionData(
    functionFragment: "hasRole",
    values: [BytesLike, string]
  ): string;
  encodeFunctionData(
    functionFragment: "listItemERC1155",
    values: [BigNumberish, BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "listItemERC721",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "listItemOnAuctionERC1155",
    values: [BigNumberish, BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "listItemOnAuctionERC721",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "listedERC1155",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "listedERC721",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "makeBidERC1155",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "makeBidERC721",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "onERC1155BatchReceived",
    values: [string, string, BigNumberish[], BigNumberish[], BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "onERC1155Received",
    values: [string, string, BigNumberish, BigNumberish, BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "onERC721Received",
    values: [string, string, BigNumberish, BytesLike]
  ): string;
  encodeFunctionData(
    functionFragment: "renounceRole",
    values: [BytesLike, string]
  ): string;
  encodeFunctionData(
    functionFragment: "revokeRole",
    values: [BytesLike, string]
  ): string;
  encodeFunctionData(
    functionFragment: "supportsInterface",
    values: [BytesLike]
  ): string;

  decodeFunctionResult(
    functionFragment: "DEFAULT_ADMIN_ROLE",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "auctionTime",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "buyItemERC1155",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "buyItemERC721",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "cancelERC1155",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "cancelERC721",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "createItemERC1155",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "createItemERC721",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "erc1155CollectionLength",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "erc1155Contract",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "erc20Contract",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "erc721CollectionLength",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "erc721Contract",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "finishAuctionERC1155",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "finishAuctionERC721",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getRoleAdmin",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "grantRole", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "hasRole", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "listItemERC1155",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "listItemERC721",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "listItemOnAuctionERC1155",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "listItemOnAuctionERC721",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "listedERC1155",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "listedERC721",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "makeBidERC1155",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "makeBidERC721",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "onERC1155BatchReceived",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "onERC1155Received",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "onERC721Received",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "renounceRole",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "revokeRole", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "supportsInterface",
    data: BytesLike
  ): Result;

  events: {
    "RoleAdminChanged(bytes32,bytes32,bytes32)": EventFragment;
    "RoleGranted(bytes32,address,address)": EventFragment;
    "RoleRevoked(bytes32,address,address)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "RoleAdminChanged"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "RoleGranted"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "RoleRevoked"): EventFragment;
}

export interface RoleAdminChangedEventObject {
  role: string;
  previousAdminRole: string;
  newAdminRole: string;
}
export type RoleAdminChangedEvent = TypedEvent<
  [string, string, string],
  RoleAdminChangedEventObject
>;

export type RoleAdminChangedEventFilter =
  TypedEventFilter<RoleAdminChangedEvent>;

export interface RoleGrantedEventObject {
  role: string;
  account: string;
  sender: string;
}
export type RoleGrantedEvent = TypedEvent<
  [string, string, string],
  RoleGrantedEventObject
>;

export type RoleGrantedEventFilter = TypedEventFilter<RoleGrantedEvent>;

export interface RoleRevokedEventObject {
  role: string;
  account: string;
  sender: string;
}
export type RoleRevokedEvent = TypedEvent<
  [string, string, string],
  RoleRevokedEventObject
>;

export type RoleRevokedEventFilter = TypedEventFilter<RoleRevokedEvent>;

export interface IVKLIMMarket extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: IVKLIMMarketInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<[string]>;

    auctionTime(overrides?: CallOverrides): Promise<[BigNumber]>;

    buyItemERC1155(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    buyItemERC721(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    cancelERC1155(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    cancelERC721(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    createItemERC1155(
      tokenURI: string,
      owner: string,
      amount: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    createItemERC721(
      tokenURI: string,
      owner: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    erc1155CollectionLength(overrides?: CallOverrides): Promise<[BigNumber]>;

    erc1155Contract(overrides?: CallOverrides): Promise<[string]>;

    erc20Contract(overrides?: CallOverrides): Promise<[string]>;

    erc721CollectionLength(overrides?: CallOverrides): Promise<[BigNumber]>;

    erc721Contract(overrides?: CallOverrides): Promise<[string]>;

    finishAuctionERC1155(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    finishAuctionERC721(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    getRoleAdmin(role: BytesLike, overrides?: CallOverrides): Promise<[string]>;

    grantRole(
      role: BytesLike,
      account: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    hasRole(
      role: BytesLike,
      account: string,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    listItemERC1155(
      tokenId: BigNumberish,
      price: BigNumberish,
      amount: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    listItemERC721(
      tokenId: BigNumberish,
      price: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    listItemOnAuctionERC1155(
      tokenId: BigNumberish,
      amount: BigNumberish,
      minPrice: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    listItemOnAuctionERC721(
      tokenId: BigNumberish,
      minPrice: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    listedERC1155(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[IVKLIMMarket.ListedNFTStructOutput]>;

    listedERC721(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[IVKLIMMarket.ListedNFTStructOutput]>;

    makeBidERC1155(
      tokenId: BigNumberish,
      price: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    makeBidERC721(
      tokenId: BigNumberish,
      price: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    onERC1155BatchReceived(
      arg0: string,
      arg1: string,
      arg2: BigNumberish[],
      arg3: BigNumberish[],
      arg4: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    onERC1155Received(
      arg0: string,
      arg1: string,
      arg2: BigNumberish,
      arg3: BigNumberish,
      arg4: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    onERC721Received(
      arg0: string,
      arg1: string,
      arg2: BigNumberish,
      arg3: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    renounceRole(
      role: BytesLike,
      account: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    revokeRole(
      role: BytesLike,
      account: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    supportsInterface(
      interfaceId: BytesLike,
      overrides?: CallOverrides
    ): Promise<[boolean]>;
  };

  DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<string>;

  auctionTime(overrides?: CallOverrides): Promise<BigNumber>;

  buyItemERC1155(
    tokenId: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  buyItemERC721(
    tokenId: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  cancelERC1155(
    tokenId: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  cancelERC721(
    tokenId: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  createItemERC1155(
    tokenURI: string,
    owner: string,
    amount: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  createItemERC721(
    tokenURI: string,
    owner: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  erc1155CollectionLength(overrides?: CallOverrides): Promise<BigNumber>;

  erc1155Contract(overrides?: CallOverrides): Promise<string>;

  erc20Contract(overrides?: CallOverrides): Promise<string>;

  erc721CollectionLength(overrides?: CallOverrides): Promise<BigNumber>;

  erc721Contract(overrides?: CallOverrides): Promise<string>;

  finishAuctionERC1155(
    tokenId: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  finishAuctionERC721(
    tokenId: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  getRoleAdmin(role: BytesLike, overrides?: CallOverrides): Promise<string>;

  grantRole(
    role: BytesLike,
    account: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  hasRole(
    role: BytesLike,
    account: string,
    overrides?: CallOverrides
  ): Promise<boolean>;

  listItemERC1155(
    tokenId: BigNumberish,
    price: BigNumberish,
    amount: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  listItemERC721(
    tokenId: BigNumberish,
    price: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  listItemOnAuctionERC1155(
    tokenId: BigNumberish,
    amount: BigNumberish,
    minPrice: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  listItemOnAuctionERC721(
    tokenId: BigNumberish,
    minPrice: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  listedERC1155(
    tokenId: BigNumberish,
    overrides?: CallOverrides
  ): Promise<IVKLIMMarket.ListedNFTStructOutput>;

  listedERC721(
    tokenId: BigNumberish,
    overrides?: CallOverrides
  ): Promise<IVKLIMMarket.ListedNFTStructOutput>;

  makeBidERC1155(
    tokenId: BigNumberish,
    price: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  makeBidERC721(
    tokenId: BigNumberish,
    price: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  onERC1155BatchReceived(
    arg0: string,
    arg1: string,
    arg2: BigNumberish[],
    arg3: BigNumberish[],
    arg4: BytesLike,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  onERC1155Received(
    arg0: string,
    arg1: string,
    arg2: BigNumberish,
    arg3: BigNumberish,
    arg4: BytesLike,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  onERC721Received(
    arg0: string,
    arg1: string,
    arg2: BigNumberish,
    arg3: BytesLike,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  renounceRole(
    role: BytesLike,
    account: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  revokeRole(
    role: BytesLike,
    account: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  supportsInterface(
    interfaceId: BytesLike,
    overrides?: CallOverrides
  ): Promise<boolean>;

  callStatic: {
    DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<string>;

    auctionTime(overrides?: CallOverrides): Promise<BigNumber>;

    buyItemERC1155(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    buyItemERC721(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    cancelERC1155(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    cancelERC721(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    createItemERC1155(
      tokenURI: string,
      owner: string,
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    createItemERC721(
      tokenURI: string,
      owner: string,
      overrides?: CallOverrides
    ): Promise<void>;

    erc1155CollectionLength(overrides?: CallOverrides): Promise<BigNumber>;

    erc1155Contract(overrides?: CallOverrides): Promise<string>;

    erc20Contract(overrides?: CallOverrides): Promise<string>;

    erc721CollectionLength(overrides?: CallOverrides): Promise<BigNumber>;

    erc721Contract(overrides?: CallOverrides): Promise<string>;

    finishAuctionERC1155(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    finishAuctionERC721(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    getRoleAdmin(role: BytesLike, overrides?: CallOverrides): Promise<string>;

    grantRole(
      role: BytesLike,
      account: string,
      overrides?: CallOverrides
    ): Promise<void>;

    hasRole(
      role: BytesLike,
      account: string,
      overrides?: CallOverrides
    ): Promise<boolean>;

    listItemERC1155(
      tokenId: BigNumberish,
      price: BigNumberish,
      amount: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    listItemERC721(
      tokenId: BigNumberish,
      price: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    listItemOnAuctionERC1155(
      tokenId: BigNumberish,
      amount: BigNumberish,
      minPrice: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    listItemOnAuctionERC721(
      tokenId: BigNumberish,
      minPrice: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    listedERC1155(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<IVKLIMMarket.ListedNFTStructOutput>;

    listedERC721(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<IVKLIMMarket.ListedNFTStructOutput>;

    makeBidERC1155(
      tokenId: BigNumberish,
      price: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    makeBidERC721(
      tokenId: BigNumberish,
      price: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    onERC1155BatchReceived(
      arg0: string,
      arg1: string,
      arg2: BigNumberish[],
      arg3: BigNumberish[],
      arg4: BytesLike,
      overrides?: CallOverrides
    ): Promise<string>;

    onERC1155Received(
      arg0: string,
      arg1: string,
      arg2: BigNumberish,
      arg3: BigNumberish,
      arg4: BytesLike,
      overrides?: CallOverrides
    ): Promise<string>;

    onERC721Received(
      arg0: string,
      arg1: string,
      arg2: BigNumberish,
      arg3: BytesLike,
      overrides?: CallOverrides
    ): Promise<string>;

    renounceRole(
      role: BytesLike,
      account: string,
      overrides?: CallOverrides
    ): Promise<void>;

    revokeRole(
      role: BytesLike,
      account: string,
      overrides?: CallOverrides
    ): Promise<void>;

    supportsInterface(
      interfaceId: BytesLike,
      overrides?: CallOverrides
    ): Promise<boolean>;
  };

  filters: {
    "RoleAdminChanged(bytes32,bytes32,bytes32)"(
      role?: BytesLike | null,
      previousAdminRole?: BytesLike | null,
      newAdminRole?: BytesLike | null
    ): RoleAdminChangedEventFilter;
    RoleAdminChanged(
      role?: BytesLike | null,
      previousAdminRole?: BytesLike | null,
      newAdminRole?: BytesLike | null
    ): RoleAdminChangedEventFilter;

    "RoleGranted(bytes32,address,address)"(
      role?: BytesLike | null,
      account?: string | null,
      sender?: string | null
    ): RoleGrantedEventFilter;
    RoleGranted(
      role?: BytesLike | null,
      account?: string | null,
      sender?: string | null
    ): RoleGrantedEventFilter;

    "RoleRevoked(bytes32,address,address)"(
      role?: BytesLike | null,
      account?: string | null,
      sender?: string | null
    ): RoleRevokedEventFilter;
    RoleRevoked(
      role?: BytesLike | null,
      account?: string | null,
      sender?: string | null
    ): RoleRevokedEventFilter;
  };

  estimateGas: {
    DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<BigNumber>;

    auctionTime(overrides?: CallOverrides): Promise<BigNumber>;

    buyItemERC1155(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    buyItemERC721(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    cancelERC1155(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    cancelERC721(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    createItemERC1155(
      tokenURI: string,
      owner: string,
      amount: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    createItemERC721(
      tokenURI: string,
      owner: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    erc1155CollectionLength(overrides?: CallOverrides): Promise<BigNumber>;

    erc1155Contract(overrides?: CallOverrides): Promise<BigNumber>;

    erc20Contract(overrides?: CallOverrides): Promise<BigNumber>;

    erc721CollectionLength(overrides?: CallOverrides): Promise<BigNumber>;

    erc721Contract(overrides?: CallOverrides): Promise<BigNumber>;

    finishAuctionERC1155(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    finishAuctionERC721(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    getRoleAdmin(
      role: BytesLike,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    grantRole(
      role: BytesLike,
      account: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    hasRole(
      role: BytesLike,
      account: string,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    listItemERC1155(
      tokenId: BigNumberish,
      price: BigNumberish,
      amount: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    listItemERC721(
      tokenId: BigNumberish,
      price: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    listItemOnAuctionERC1155(
      tokenId: BigNumberish,
      amount: BigNumberish,
      minPrice: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    listItemOnAuctionERC721(
      tokenId: BigNumberish,
      minPrice: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    listedERC1155(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    listedERC721(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    makeBidERC1155(
      tokenId: BigNumberish,
      price: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    makeBidERC721(
      tokenId: BigNumberish,
      price: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    onERC1155BatchReceived(
      arg0: string,
      arg1: string,
      arg2: BigNumberish[],
      arg3: BigNumberish[],
      arg4: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    onERC1155Received(
      arg0: string,
      arg1: string,
      arg2: BigNumberish,
      arg3: BigNumberish,
      arg4: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    onERC721Received(
      arg0: string,
      arg1: string,
      arg2: BigNumberish,
      arg3: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    renounceRole(
      role: BytesLike,
      account: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    revokeRole(
      role: BytesLike,
      account: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    supportsInterface(
      interfaceId: BytesLike,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    DEFAULT_ADMIN_ROLE(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    auctionTime(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    buyItemERC1155(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    buyItemERC721(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    cancelERC1155(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    cancelERC721(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    createItemERC1155(
      tokenURI: string,
      owner: string,
      amount: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    createItemERC721(
      tokenURI: string,
      owner: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    erc1155CollectionLength(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    erc1155Contract(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    erc20Contract(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    erc721CollectionLength(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    erc721Contract(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    finishAuctionERC1155(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    finishAuctionERC721(
      tokenId: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    getRoleAdmin(
      role: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    grantRole(
      role: BytesLike,
      account: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    hasRole(
      role: BytesLike,
      account: string,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    listItemERC1155(
      tokenId: BigNumberish,
      price: BigNumberish,
      amount: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    listItemERC721(
      tokenId: BigNumberish,
      price: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    listItemOnAuctionERC1155(
      tokenId: BigNumberish,
      amount: BigNumberish,
      minPrice: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    listItemOnAuctionERC721(
      tokenId: BigNumberish,
      minPrice: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    listedERC1155(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    listedERC721(
      tokenId: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    makeBidERC1155(
      tokenId: BigNumberish,
      price: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    makeBidERC721(
      tokenId: BigNumberish,
      price: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    onERC1155BatchReceived(
      arg0: string,
      arg1: string,
      arg2: BigNumberish[],
      arg3: BigNumberish[],
      arg4: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    onERC1155Received(
      arg0: string,
      arg1: string,
      arg2: BigNumberish,
      arg3: BigNumberish,
      arg4: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    onERC721Received(
      arg0: string,
      arg1: string,
      arg2: BigNumberish,
      arg3: BytesLike,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    renounceRole(
      role: BytesLike,
      account: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    revokeRole(
      role: BytesLike,
      account: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    supportsInterface(
      interfaceId: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;
  };
}
